library angular2.src.core.compiler.pipeline.resolve_css_dart;

import './compile_step.dart' show CompileStep;
import './compile_element.dart' show CompileElement;
import './compile_control.dart' show CompileControl;
import 'package:angular2/src/core/compiler/directive_metadata.dart'
    show DirectiveMetadata;
import 'package:angular2/src/core/compiler/shadow_dom_strategy.dart'
    show ShadowDomStrategy;
import 'package:angular2/src/dom/dom_adapter.dart' show DOM;
import 'package:angular2/src/facade/lang.dart' show Type;
import 'package:angular2/src/facade/async.dart' show PromiseWrapper;
import 'package:angular2/src/facade/collection.dart' show ListWrapper;

class ResolveCss extends CompileStep {
  ShadowDomStrategy _strategy;
  Type _component;
  String _templateUrl;
  ResolveCss(DirectiveMetadata cmpMetadata, ShadowDomStrategy strategy,
      String templateUrl)
      : super() {
    this._strategy = strategy;
    this._component = cmpMetadata.type;
    this._templateUrl = templateUrl;
  }
  process(
      CompileElement parent, CompileElement current, CompileControl control) {
    if (DOM.tagName(current.element) == 'STYLE') {
      current.ignoreBindings = true;
      var styleEl = current.element;
      var css = DOM.getText(styleEl);
      css = this._strategy.transformStyleText(
          css, this._templateUrl, this._component);
      if (PromiseWrapper.isPromise(css)) {
        ListWrapper.push(parent.inheritedProtoView.stylePromises, css);
        DOM.setText(styleEl, '');
        css.then((css) {
          DOM.setText(styleEl, css);
        });
      } else {
        DOM.setText(styleEl, css);
      }
      this._strategy.handleStyleElement(styleEl);
    }
  }
}
